<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.polco.impl;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.PrintWriter;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.StringWriter;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.Writer;<a name="line.38"></a>
<FONT color="green">039</FONT>    <a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.math.array.ArrayOperations;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.math.array.NumberArrayOperations;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.math.array.NumberOperators;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.math.linalg.LinAlgOperations;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.math.operator.UnaryOperator;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.polco.PolyhedralCone;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    /**<a name="line.47"></a>
<FONT color="green">048</FONT>     * Implements methods common to most implementations of {@link PolyhedralCone}, <a name="line.48"></a>
<FONT color="green">049</FONT>     * such as {@link #toString()}.<a name="line.49"></a>
<FONT color="green">050</FONT>     * <a name="line.50"></a>
<FONT color="green">051</FONT>     * @type Num    the number type of a single number<a name="line.51"></a>
<FONT color="green">052</FONT>     * @type Arr    the number type of an array of numbers<a name="line.52"></a>
<FONT color="green">053</FONT>     */<a name="line.53"></a>
<FONT color="green">054</FONT>    abstract public class AbstractPolyhedralCone&lt;Num extends Number, Arr&gt; implements PolyhedralCone&lt;Num, Arr&gt; {<a name="line.54"></a>
<FONT color="green">055</FONT>    <a name="line.55"></a>
<FONT color="green">056</FONT>            protected final LinAlgOperations&lt;Num, Arr&gt;                linAlgOps;<a name="line.56"></a>
<FONT color="green">057</FONT>            protected final ArrayOperations&lt;Arr&gt;                      arrayOps;<a name="line.57"></a>
<FONT color="green">058</FONT>            protected final NumberArrayOperations&lt;Num, Arr&gt;   numberArrayOps;<a name="line.58"></a>
<FONT color="green">059</FONT>            protected final NumberOperators&lt;Num, Arr&gt;         numberOps;<a name="line.59"></a>
<FONT color="green">060</FONT>            <a name="line.60"></a>
<FONT color="green">061</FONT>            /**<a name="line.61"></a>
<FONT color="green">062</FONT>             * Constructor with linalg operations<a name="line.62"></a>
<FONT color="green">063</FONT>             * <a name="line.63"></a>
<FONT color="green">064</FONT>             * @param linAlgOps     linalg operations<a name="line.64"></a>
<FONT color="green">065</FONT>             */<a name="line.65"></a>
<FONT color="green">066</FONT>            public AbstractPolyhedralCone(LinAlgOperations&lt;Num, Arr&gt; linAlgOps) {<a name="line.66"></a>
<FONT color="green">067</FONT>                    this.linAlgOps          = linAlgOps;<a name="line.67"></a>
<FONT color="green">068</FONT>                    this.arrayOps           = linAlgOps.getArrayOperations();<a name="line.68"></a>
<FONT color="green">069</FONT>                    this.numberArrayOps     = linAlgOps.getNumberArrayOperations();<a name="line.69"></a>
<FONT color="green">070</FONT>                    this.numberOps          = linAlgOps.getNumberOperators();<a name="line.70"></a>
<FONT color="green">071</FONT>            }<a name="line.71"></a>
<FONT color="green">072</FONT>            <a name="line.72"></a>
<FONT color="green">073</FONT>            public LinAlgOperations&lt;Num, Arr&gt; getLinAlgOperations() {<a name="line.73"></a>
<FONT color="green">074</FONT>                    return linAlgOps;<a name="line.74"></a>
<FONT color="green">075</FONT>            }<a name="line.75"></a>
<FONT color="green">076</FONT>            <a name="line.76"></a>
<FONT color="green">077</FONT>            @Override<a name="line.77"></a>
<FONT color="green">078</FONT>            public int hashCode() {<a name="line.78"></a>
<FONT color="green">079</FONT>                    int code = 0;<a name="line.79"></a>
<FONT color="green">080</FONT>                    final int dims  = getDimensions();<a name="line.80"></a>
<FONT color="green">081</FONT>                    final int rowsA = getRowCountA();<a name="line.81"></a>
<FONT color="green">082</FONT>                    final int rowsB = getRowCountB();<a name="line.82"></a>
<FONT color="green">083</FONT>                    for (int c = 0; c &lt; dims; c++) {<a name="line.83"></a>
<FONT color="green">084</FONT>                            for (int r = 0; r &lt; rowsA; r++) {<a name="line.84"></a>
<FONT color="green">085</FONT>                                    code ^= getA(r, c).hashCode();<a name="line.85"></a>
<FONT color="green">086</FONT>                            }<a name="line.86"></a>
<FONT color="green">087</FONT>                            for (int r = 0; r &lt; rowsB; r++) {<a name="line.87"></a>
<FONT color="green">088</FONT>                                    code ^= getB(r, c).hashCode();<a name="line.88"></a>
<FONT color="green">089</FONT>                            }<a name="line.89"></a>
<FONT color="green">090</FONT>                    }<a name="line.90"></a>
<FONT color="green">091</FONT>                    return code;<a name="line.91"></a>
<FONT color="green">092</FONT>            }<a name="line.92"></a>
<FONT color="green">093</FONT>            @Override<a name="line.93"></a>
<FONT color="green">094</FONT>            public boolean equals(Object obj) {<a name="line.94"></a>
<FONT color="green">095</FONT>                    if (obj == this) return true;<a name="line.95"></a>
<FONT color="green">096</FONT>                    if (obj instanceof PolyhedralCone) {<a name="line.96"></a>
<FONT color="green">097</FONT>                            final PolyhedralCone other = (PolyhedralCone)obj;<a name="line.97"></a>
<FONT color="green">098</FONT>                            final int dims  = getDimensions();<a name="line.98"></a>
<FONT color="green">099</FONT>                            final int rowsA = getRowCountA();<a name="line.99"></a>
<FONT color="green">100</FONT>                            final int rowsB = getRowCountB();<a name="line.100"></a>
<FONT color="green">101</FONT>                            if (dims != other.getDimensions()) return false;<a name="line.101"></a>
<FONT color="green">102</FONT>                            if (rowsA != other.getRowCountA()) return false;<a name="line.102"></a>
<FONT color="green">103</FONT>                            if (rowsB != other.getRowCountB()) return false;<a name="line.103"></a>
<FONT color="green">104</FONT>                            for (int c = 0; c &lt; dims; c++) {<a name="line.104"></a>
<FONT color="green">105</FONT>                                    for (int r = 0; r &lt; rowsA; r++) {<a name="line.105"></a>
<FONT color="green">106</FONT>                                            if (!getA(r, c).equals(other.getA(r, c))) {<a name="line.106"></a>
<FONT color="green">107</FONT>                                                    return false;<a name="line.107"></a>
<FONT color="green">108</FONT>                                            }<a name="line.108"></a>
<FONT color="green">109</FONT>                                    }<a name="line.109"></a>
<FONT color="green">110</FONT>                                    for (int r = 0; r &lt; rowsB; r++) {<a name="line.110"></a>
<FONT color="green">111</FONT>                                            if (!getB(r, c).equals(other.getB(r, c))) {<a name="line.111"></a>
<FONT color="green">112</FONT>                                                    return false;<a name="line.112"></a>
<FONT color="green">113</FONT>                                            }<a name="line.113"></a>
<FONT color="green">114</FONT>                                    }<a name="line.114"></a>
<FONT color="green">115</FONT>                            }<a name="line.115"></a>
<FONT color="green">116</FONT>                            return true;<a name="line.116"></a>
<FONT color="green">117</FONT>                    }<a name="line.117"></a>
<FONT color="green">118</FONT>                    return false;<a name="line.118"></a>
<FONT color="green">119</FONT>            }<a name="line.119"></a>
<FONT color="green">120</FONT>    <a name="line.120"></a>
<FONT color="green">121</FONT>            /**<a name="line.121"></a>
<FONT color="green">122</FONT>             * The given vector is normalized and returned. Normalizing means for <a name="line.122"></a>
<FONT color="green">123</FONT>             * instance reducing fraction numbers or rounding. The vector is not cloned,<a name="line.123"></a>
<FONT color="green">124</FONT>             * that is, the returned value is the same instance as {@code vec}.<a name="line.124"></a>
<FONT color="green">125</FONT>             * <a name="line.125"></a>
<FONT color="green">126</FONT>             * @param vec   the vector to normalize<a name="line.126"></a>
<FONT color="green">127</FONT>             * @return      the normalized vector, the same instance as {@code vec}<a name="line.127"></a>
<FONT color="green">128</FONT>             */<a name="line.128"></a>
<FONT color="green">129</FONT>            protected Arr normalize(Arr vec) {<a name="line.129"></a>
<FONT color="green">130</FONT>                    final LinAlgOperations&lt;Num, Arr&gt; lops = getLinAlgOperations();<a name="line.130"></a>
<FONT color="green">131</FONT>                    final ArrayOperations&lt;Arr&gt; aops = lops.getArrayOperations();<a name="line.131"></a>
<FONT color="green">132</FONT>                    final NumberOperators&lt;Num, Arr&gt; nops = lops.getNumberOperators();<a name="line.132"></a>
<FONT color="green">133</FONT>                    final UnaryOperator&lt;Num, Arr&gt; norm = nops.unary(UnaryOperator.Id.normalize);<a name="line.133"></a>
<FONT color="green">134</FONT>                    final int size = aops.getLength(vec);<a name="line.134"></a>
<FONT color="green">135</FONT>                    for (int i = 0; i &lt; size; i++) {<a name="line.135"></a>
<FONT color="green">136</FONT>                            norm.operate(vec, i, vec, i);<a name="line.136"></a>
<FONT color="green">137</FONT>                    }<a name="line.137"></a>
<FONT color="green">138</FONT>                    return vec;<a name="line.138"></a>
<FONT color="green">139</FONT>            }<a name="line.139"></a>
<FONT color="green">140</FONT>            /**<a name="line.140"></a>
<FONT color="green">141</FONT>             * The given matrix is normalized and returned. Normalizing means for <a name="line.141"></a>
<FONT color="green">142</FONT>             * instance reducing fraction numbers or rounding. The matrix is not cloned,<a name="line.142"></a>
<FONT color="green">143</FONT>             * that is, the returned value is the same instance as {@code mx}.<a name="line.143"></a>
<FONT color="green">144</FONT>             * <a name="line.144"></a>
<FONT color="green">145</FONT>             * @param mx    the matrix to normalize<a name="line.145"></a>
<FONT color="green">146</FONT>             * @return      the normalized matrix, the same instance as {@code mx}<a name="line.146"></a>
<FONT color="green">147</FONT>             */<a name="line.147"></a>
<FONT color="green">148</FONT>            protected Arr[] normalize(Arr[] mx) {<a name="line.148"></a>
<FONT color="green">149</FONT>                    for (int r = 0; r &lt; mx.length; r++) {<a name="line.149"></a>
<FONT color="green">150</FONT>                            normalize(mx[r]);<a name="line.150"></a>
<FONT color="green">151</FONT>                    }<a name="line.151"></a>
<FONT color="green">152</FONT>                    return mx;<a name="line.152"></a>
<FONT color="green">153</FONT>            }<a name="line.153"></a>
<FONT color="green">154</FONT>    <a name="line.154"></a>
<FONT color="green">155</FONT>            /**<a name="line.155"></a>
<FONT color="green">156</FONT>             * Returns a matrix dimension string. If {@code matrixA} is {@code true},<a name="line.156"></a>
<FONT color="green">157</FONT>             * the string is returned for matrix {@code A}, otherwise for matrix <a name="line.157"></a>
<FONT color="green">158</FONT>             * {@code B}. The returned string looks for instance as follows: <a name="line.158"></a>
<FONT color="green">159</FONT>             * {@code "A:7x2"}<a name="line.159"></a>
<FONT color="green">160</FONT>             */<a name="line.160"></a>
<FONT color="green">161</FONT>            protected String getMatrixDimensionString(boolean matrixA) {<a name="line.161"></a>
<FONT color="green">162</FONT>                    final int dims = getDimensions();<a name="line.162"></a>
<FONT color="green">163</FONT>                    return matrixA ?<a name="line.163"></a>
<FONT color="green">164</FONT>                            "A:" + getRowCountA() + "x" + dims :<a name="line.164"></a>
<FONT color="green">165</FONT>                            "B:" + getRowCountB() + "x" + dims;<a name="line.165"></a>
<FONT color="green">166</FONT>            }<a name="line.166"></a>
<FONT color="green">167</FONT>            /**<a name="line.167"></a>
<FONT color="green">168</FONT>             * Returns a matrix string. If {@code matrixA} is {@code true}, the string <a name="line.168"></a>
<FONT color="green">169</FONT>             * is returned for matrix {@code A}, otherwise for matrix {@code B}. The <a name="line.169"></a>
<FONT color="green">170</FONT>             * returned string spans multiple lines and looks for instance as follows:<a name="line.170"></a>
<FONT color="green">171</FONT>             * &lt;pre&gt; <a name="line.171"></a>
<FONT color="green">172</FONT>             * B = 5x2 {<a name="line.172"></a>
<FONT color="green">173</FONT>             *   [ 0 , -3 ]<a name="line.173"></a>
<FONT color="green">174</FONT>             *   [ 1 , 1 ]<a name="line.174"></a>
<FONT color="green">175</FONT>             *   [ -1 , 1 ]<a name="line.175"></a>
<FONT color="green">176</FONT>             *   [ 1/2 , -1/2 ]<a name="line.176"></a>
<FONT color="green">177</FONT>             *   [ 1 , 1 ]<a name="line.177"></a>
<FONT color="green">178</FONT>             * }<a name="line.178"></a>
<FONT color="green">179</FONT>             * &lt;/pre&gt; <a name="line.179"></a>
<FONT color="green">180</FONT>             */<a name="line.180"></a>
<FONT color="green">181</FONT>            protected void appendMatrixString(boolean matrixA, PrintWriter pw) {<a name="line.181"></a>
<FONT color="green">182</FONT>                    final int dims = getDimensions();<a name="line.182"></a>
<FONT color="green">183</FONT>                    if (matrixA) {<a name="line.183"></a>
<FONT color="green">184</FONT>                            final int rows = getRowCountA();<a name="line.184"></a>
<FONT color="green">185</FONT>                            pw.println("A = " + rows + "x" + dims + " {");<a name="line.185"></a>
<FONT color="green">186</FONT>                            for (int r = 0; r &lt; rows; r++) {<a name="line.186"></a>
<FONT color="green">187</FONT>                                    for (int c = 0; c &lt; dims; c++) {<a name="line.187"></a>
<FONT color="green">188</FONT>                                            pw.print(c == 0 ? "  [ " : " , ");<a name="line.188"></a>
<FONT color="green">189</FONT>                                            pw.print(getA(r, c));<a name="line.189"></a>
<FONT color="green">190</FONT>                                    }<a name="line.190"></a>
<FONT color="green">191</FONT>                                    pw.println(" ]");<a name="line.191"></a>
<FONT color="green">192</FONT>                            }<a name="line.192"></a>
<FONT color="green">193</FONT>                    }<a name="line.193"></a>
<FONT color="green">194</FONT>                    else {<a name="line.194"></a>
<FONT color="green">195</FONT>                            final int rows = getRowCountB();<a name="line.195"></a>
<FONT color="green">196</FONT>                            pw.println("B = " + rows + "x" + dims + " {");<a name="line.196"></a>
<FONT color="green">197</FONT>                            for (int r = 0; r &lt; rows; r++) {<a name="line.197"></a>
<FONT color="green">198</FONT>                                    for (int c = 0; c &lt; dims; c++) {<a name="line.198"></a>
<FONT color="green">199</FONT>                                            pw.print(c == 0 ? "  [ " : " , ");<a name="line.199"></a>
<FONT color="green">200</FONT>                                            pw.print(getB(r, c));<a name="line.200"></a>
<FONT color="green">201</FONT>                                    }<a name="line.201"></a>
<FONT color="green">202</FONT>                                    pw.println(" ]");<a name="line.202"></a>
<FONT color="green">203</FONT>                            }                       <a name="line.203"></a>
<FONT color="green">204</FONT>                    }<a name="line.204"></a>
<FONT color="green">205</FONT>                    pw.println("}");<a name="line.205"></a>
<FONT color="green">206</FONT>            }<a name="line.206"></a>
<FONT color="green">207</FONT>            public String toMultilineString() {<a name="line.207"></a>
<FONT color="green">208</FONT>                    final StringWriter sw = new StringWriter();<a name="line.208"></a>
<FONT color="green">209</FONT>                    writeToMultiline(sw);<a name="line.209"></a>
<FONT color="green">210</FONT>                    return sw.toString();<a name="line.210"></a>
<FONT color="green">211</FONT>            }<a name="line.211"></a>
<FONT color="green">212</FONT>            public void writeToMultiline(Writer writer) {<a name="line.212"></a>
<FONT color="green">213</FONT>                    final PrintWriter pw = writer instanceof PrintWriter ? (PrintWriter)writer : new PrintWriter(writer);<a name="line.213"></a>
<FONT color="green">214</FONT>                    pw.println("P = { A x = 0 , B x &gt;= 0 }");<a name="line.214"></a>
<FONT color="green">215</FONT>                    appendMatrixString(true, pw);<a name="line.215"></a>
<FONT color="green">216</FONT>                    appendMatrixString(false, pw);<a name="line.216"></a>
<FONT color="green">217</FONT>                    pw.flush();<a name="line.217"></a>
<FONT color="green">218</FONT>            }<a name="line.218"></a>
<FONT color="green">219</FONT>            @Override<a name="line.219"></a>
<FONT color="green">220</FONT>            public String toString() {<a name="line.220"></a>
<FONT color="green">221</FONT>                    return <a name="line.221"></a>
<FONT color="green">222</FONT>                            "P = { A x = 0 , B x &gt;= 0 , " +<a name="line.222"></a>
<FONT color="green">223</FONT>                            getMatrixDimensionString(true) + " , " +<a name="line.223"></a>
<FONT color="green">224</FONT>                            getMatrixDimensionString(false) + " }";<a name="line.224"></a>
<FONT color="green">225</FONT>            }<a name="line.225"></a>
<FONT color="green">226</FONT>            <a name="line.226"></a>
<FONT color="green">227</FONT>    <a name="line.227"></a>
<FONT color="green">228</FONT>    }<a name="line.228"></a>




























































</PRE>
</BODY>
</HTML>
